diff --git a/pimd/pim_igmpv2.c b/pimd/pim_igmpv2.c
index af598d040dd..ecf60f39207 100644
--- a/pimd/pim_igmpv2.c
+++ b/pimd/pim_igmpv2.c
@@ -157,6 +157,8 @@ int igmp_v2_recv_leave(struct igmp_sock *igmp, struct in_addr from,
 	struct interface *ifp = igmp->interface;
 	struct in_addr group_addr;
 	char group_str[INET_ADDRSTRLEN];
+	uint16_t recv_checksum;
+	uint16_t checksum;
 
 	on_trace(__func__, igmp->interface, from);
 
@@ -170,6 +172,20 @@ int igmp_v2_recv_leave(struct igmp_sock *igmp, struct in_addr from,
 		return -1;
 	}
 
+	recv_checksum = *(uint16_t *)(igmp_msg + IGMP_CHECKSUM_OFFSET);
+
+	/* for computing checksum */
+	*(uint16_t *)(igmp_msg + IGMP_CHECKSUM_OFFSET) = 0;
+	checksum = in_cksum(igmp_msg, igmp_msg_len);
+	if (checksum != recv_checksum) {
+		zlog_warn(
+			"Recv IGMPv2 LEAVE from %s on %s: checksum mismatch:"
+			" received=%x computed=%x",
+			from_str, ifp->name, recv_checksum,
+			checksum);
+		return -1;
+	}
+
 	/* Collecting IGMP Rx stats */
 	igmp->rx_stats.leave_v2++;
 
